function F = coefficients(x,P)

F = zeros(size(x));
for icol = 1:size(F,2)
    % Parameters
    Skappay0 = x(1,icol);
    Skappay1 = x(2,icol);
    Setay0 = x(3,icol);
    Setay1 = x(4,icol);
    Setay2 = x(5,icol);
    Setay3 = x(6,icol);
    Skappad0 = x(7,icol);
    Skappad1 = x(8,icol);
    Setad0 = x(9,icol);
    Setad1 = x(10,icol);
    Setad2 = x(11,icol);
    Setad3 = x(12,icol);
    
    % Kappas (by hand)
    F(1,icol) = -Skappay0+log(1+exp(Setay0))-Skappay1*Setay0;
    F(2,icol) = -Skappay1+exp(Setay0)/(1+exp(Setay0));
    F(3,icol) = -Skappad0+log(1+exp(Setad0))-Skappad1*Setad0;
    F(4,icol) = -Skappad1+exp(Setad0)/(1+exp(Setad0));
    
    % Etas (from ../Coefficients/baseline.nb)
    F(5:12,icol) = ...
        [(1/2).*P.theta.*((-2).*P.muy.*P.psi.^(-1)+2.*(log(P.beta)+P.muy+ ...
        Skappay0+Setay0.*((-1)+Skappay1)+P.sigy^2.*Setay3.*Skappay1+(-1).* ...
        P.rhosigy.*P.sigy^2.*Setay3.*Skappay1)+P.psi.^(-2).*P.theta.*( ...
        P.piya.^2.*((-1)+P.psi).^2.*P.siga^2+2.*P.piya.*((-1)+P.psi).* ...
        P.psi.*P.siga^2.*((-1).*P.omega+Setay1.*Skappay1)+P.psi.^2.*( ...
        P.nuy.^2.*Setay3.^2.*Skappay1.^2+P.siga^2.*(P.omega+(-1).*Setay1.* ...
        Skappay1).^2))),P.theta.*(1+(-1).*P.omega.*P.rhoa+Setay1.*((-1)+ ...
        P.rhoa.*Skappay1)),P.psi.^(-1).*P.theta.*((-1)+P.psi+P.psi.* ...
        Setay2.*((-1)+P.rhox.*Skappay1)),(1/2).*P.theta.*(2.*Setay3.*((-1) ...
        +P.rhosigy.*Skappay1)+P.theta.*(1+P.psi.^(-2)+(-2).*P.psi.^(-1)+ ...
        P.psix.^2.*Setay2.^2.*Skappay1.^2)),P.mud+log(P.beta).*P.theta+( ...
        -1).*P.muy.*P.psi.^(-1).*P.theta+(-1).*Setad0+Skappad0+(Setad0+( ...
        -1).*((-1)+P.rhosigy).*P.sigy^2.*Setad3).*Skappad1+(1/2).*(P.nuy.* ...
        Setad3.*Skappad1+P.nuy.*((-1)+P.theta).*Setay3.*Skappay1).^2+((-1) ...
        +P.theta).*(P.muy+(-1).*Setay0+Skappay0+(Setay0+(-1).*((-1)+ ...
        P.rhosigy).*P.sigy^2.*Setay3).*Skappay1)+(1/2).*P.psi.^(-2).* ...
        P.siga^2.*(P.piya.*((-1)+P.psi).*P.theta+P.psi.*(P.pida+(-1).* ...
        P.piya+Setad1.*Skappad1+(-1).*Setay1.*Skappay1)+P.psi.*P.theta.*(( ...
        -1).*P.omega+Setay1.*Skappay1)).^2,P.theta+(-1).*P.omega.*P.rhoa.* ...
        P.theta+Setad1.*((-1)+P.rhoa.*Skappad1)+((-1)+P.theta).*Setay1.*(( ...
        -1)+P.rhoa.*Skappay1),(-1)+P.phid+P.theta+(-1).*P.psi.^(-1).* ...
        P.theta+Setad2.*((-1)+P.rhox.*Skappad1)+((-1)+P.theta).*Setay2.*(( ...
        -1)+P.rhox.*Skappay1),(1/2).*(P.psid.^2+P.psi.^(-2).*(P.psi+ ...
        P.theta+(-1).*P.psi.*P.theta).^2+(-2).*Setad3+2.*P.rhosigy.* ...
        Setad3.*Skappad1+2.*((-1)+P.theta).*Setay3.*((-1)+P.rhosigy.* ...
        Skappay1)+P.psix.^2.*(Setad2.*Skappad1+((-1)+P.theta).*Setay2.* ...
        Skappay1).^2)];
end