function F = coefficients(x,P)

F = zeros(size(x));
for icol = 1:size(F,2)
    % Parameters
    Skappay0 = x(1,icol);
    Skappay1 = x(2,icol);
    Setay0 = x(3,icol);
    Setay2 = x(4,icol);
    Skappad0 = x(5,icol);
    Skappad1 = x(6,icol);
    Setad0 = x(7,icol);
    Setad2 = x(8,icol);
    
    % Kappas (by hand)
    F(1,icol) = -Skappay0+log(1+exp(Setay0))-Skappay1*Setay0;
    F(2,icol) = -Skappay1+exp(Setay0)/(1+exp(Setay0));
    F(3,icol) = -Skappad0+log(1+exp(Setad0))-Skappad1*Setad0;
    F(4,icol) = -Skappad1+exp(Setad0)/(1+exp(Setad0));
    
    % Etas (from ../Coefficients/baseline.nb)
    F(5:8,icol) = ...
        [(1/2).*P.theta.*((-2).*P.muy.*P.psi.^(-1)+2.*(log(P.beta)+P.muy+ ...
        Skappay0)+2.*Setay0.*((-1)+Skappay1)+P.psi.^(-2).*P.sigy^2.* ...
        P.theta.*(1+(-2).*P.psi+P.psi.^2.*(1+P.psix.^2.*Setay2.^2.* ...
        Skappay1.^2))),P.psi.^(-1).*P.theta.*((-1)+P.psi+P.psi.*Setay2.*(( ...
        -1)+P.rhox.*Skappay1)),P.mud+(1/2).*P.psid.^2.*P.sigy^2+log( ...
        P.beta).*P.theta+(-1).*P.muy.*P.psi.^(-1).*P.theta+(1/2).*P.psi.^( ...
        -2).*P.sigy^2.*(((-1)+P.pidy).*P.psi+((-1)+P.psi).*P.theta).^2+( ...
        -1).*Setad0+Skappad0+Setad0.*Skappad1+((-1)+P.theta).*(P.muy+ ...
        Skappay0+Setay0.*((-1)+Skappay1))+(1/2).*P.psix.^2.*P.sigy^2.*( ...
        Setad2.*Skappad1+((-1)+P.theta).*Setay2.*Skappay1).^2,...
        (-1)+P.phid+P.theta+(-1).*P.psi.^(-1).*P.theta+Setad2.*((-1)+ ...
        P.rhox.*Skappad1)+((-1)+P.theta).*Setay2.*((-1)+P.rhox.*Skappay1)];
end