% Valuation Risk Revalued (2021)
% 	Oliver de Groot (University of Liverpool)
% 	Alexander W. Richter (Dallas Fed)
% 	Nathaniel A. Throckmorton (William & Mary)
% 
% Generate all figures and tables
close all
clear
clc
addpath('MATLAB\Toolbox\')

disp('Figure 1: State-space indifference curves')
run MATLAB/script_figure_indifference_curves.m

disp('Figure 2: Equilibrium outcomes')
run MATLAB/script_figure_asset_moments.m

disp('Table 2: Baseline model parameter estimates')
disp('Table 3: Baseline model model-implied moments')
run MATLAB/script_tables_baseline.m

disp('Figure 3: Baseline model estimates w.r.t. IES')
run MATLAB/script_figure_baseline_fixgamma.m

disp('Table 4: LRR models parameter estimates')
disp('Table 5: LRR models model-implied moments')
run MATLAB/script_tables_LRR.m

disp('Table 6: Extended models parameter estimates')
disp('Table 7: Extended models model-implied moments')
run MATLAB/script_tables_extended.m